package hu.bme.mit.socialnetwork.form;

import hu.bme.mit.socialnetwork.form.hierarchy.SocialnetworkTreeFactory;
import hu.bme.mit.socialnetwork.form.hierarchy.SocialnetworkStructureAdvisor;
import hu.bme.mit.socialnetwork.form.socialnetwork.Community;
import hu.bme.mit.socialnetwork.form.socialnetwork.Person;
import hu.bme.mit.socialnetwork.form.socialnetwork.SocialNetwork;
import hu.bme.mit.socialnetwork.form.socialnetwork.SocialnetworkPackage;
import hu.bme.mit.socialnetwork.form.socialnetwork.provider.SocialnetworkItemProviderAdapterFactory;

import java.io.IOException;

import org.eclipse.core.databinding.observable.IObservable;
import org.eclipse.core.databinding.observable.list.IObservableList;
import org.eclipse.core.databinding.observable.masterdetail.IObservableFactory;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.databinding.EMFProperties;
import org.eclipse.emf.databinding.IEMFListProperty;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorSite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.part.EditorPart;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.databinding.viewers.ObservableListTreeContentProvider;
import org.eclipse.jface.databinding.viewers.TreeStructureAdvisor;
import org.eclipse.jface.layout.TreeColumnLayout;

public class SocialNetworkFormEditor extends EditorPart {
	Resource resource;
	SocialNetwork network;
	boolean dirty = false;

	@Override
	public void doSave(IProgressMonitor monitor) {
		// TODO Auto-generated method stub

	}

	@Override
	public void doSaveAs() {
		// TODO Auto-generated method stub

	}

	@Override
	public void init(IEditorSite site, IEditorInput input)
			throws PartInitException {
		setSite(site);
		setInput(input);
		IFile file = (IFile) input.getAdapter(IFile.class);

		ResourceSet set = new ResourceSetImpl();
		resource = set.createResource(URI.createPlatformResourceURI(file.getFullPath()
				.toString(), false));
		try {
			resource.load(null);
			network = (SocialNetwork) resource.getContents().get(0);
			dirty = false;

		} catch (IOException e) {
			throw new PartInitException("Cannot load model", e);
		}
	}

	@Override
	public boolean isDirty() {
		return dirty;
	}

	@Override
	public boolean isSaveAsAllowed() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void createPartControl(Composite parent) {
		parent.setLayout(new FillLayout(SWT.HORIZONTAL));

		SashForm sashForm = new SashForm(parent, SWT.BORDER | SWT.SMOOTH);

		Composite composite = new Composite(sashForm, SWT.NONE);
		composite.setLayout(new TreeColumnLayout());

		TreeViewer treeViewer = new TreeViewer(composite, SWT.BORDER);
		treeViewer.setAutoExpandLevel(3);
		Tree tree = treeViewer.getTree();
		tree.setHeaderVisible(true);
		tree.setLinesVisible(true);

		SashForm sashForm_1 = new SashForm(sashForm, SWT.NONE);
		sashForm_1.setOrientation(SWT.VERTICAL);
		sashForm.setWeights(new int[] { 1, 1 });
		// Setting up tree viewer
		ObservableListTreeContentProvider cp = new ObservableListTreeContentProvider(
				new SocialnetworkTreeFactory(), new SocialnetworkStructureAdvisor());
		treeViewer.setContentProvider(cp);
		// Generic EMF Edit label provider
		SocialnetworkItemProviderAdapterFactory factory = new SocialnetworkItemProviderAdapterFactory();
		treeViewer.setLabelProvider(new AdapterFactoryLabelProvider(factory));
		
		IEMFListProperty communities = EMFProperties.list(SocialnetworkPackage.Literals.SOCIAL_NETWORK__ENTITIES);
		treeViewer.setInput(communities.observe(network));
	}

	@Override
	public void setFocus() {
		// TODO Auto-generated method stub

	}

}
