package hu.bme.mit.socialnetwork.form.hierarchy;

import hu.bme.mit.socialnetwork.form.socialnetwork.Community;
import hu.bme.mit.socialnetwork.form.socialnetwork.Person;
import hu.bme.mit.socialnetwork.form.socialnetwork.SocialNetwork;
import hu.bme.mit.socialnetwork.form.socialnetwork.SocialnetworkPackage;

import org.eclipse.core.databinding.observable.IObservable;
import org.eclipse.core.databinding.observable.list.IObservableList;
import org.eclipse.core.databinding.observable.masterdetail.IObservableFactory;
import org.eclipse.emf.databinding.EMFProperties;
import org.eclipse.emf.databinding.FeaturePath;
import org.eclipse.emf.databinding.IEMFListProperty;
import org.eclipse.emf.databinding.IEMFProperty;

/**
 * @author Zoltan Ujhelyi
 *
 */
public class SocialnetworkTreeFactory implements IObservableFactory {

	private IEMFListProperty multi = EMFProperties.multiList(
			SocialnetworkPackage.Literals.COMMUNITY__CHILDREN,
			SocialnetworkPackage.Literals.COMMUNITY__MEMBERS);
	private IEMFListProperty communities = EMFProperties
			.list(SocialnetworkPackage.Literals.SOCIAL_ENTITY__NAME);

	@Override
	public IObservable createObservable(Object target) {
		if (target instanceof IObservableList) {
			return (IObservable) target;
		} else if (target instanceof Community) {
			return multi.observe(target);
		} else if (target instanceof SocialNetwork) {
			return communities.observe(target);
		}
		return null;
	}

}
